<script setup>
import { computed, ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import LevelList from "@components/Game/LevelList.vue";
import SessionList from "@components/Game/SessionList.vue";
import ModalOverlay from "@components/Template/ModalOverlay.vue";
import AddLevelModal from "@components/Template/AddLevelModal.vue";

// Connect to Store and Router
const store = useStore();
const router = useRouter();

// Compute necessary Store values for Component
const game = computed(() => store.state.game.selected);
const levels = computed(() => store.getters["game/extendedLevelList"]);
const sessions = computed(() => store.getters["live/sessionsByLevel"]);
const isLive = computed(() => store.state.live.isLive);

// Create local References
const deleteLevelModal = ref({ visible: false, name: null });

function clickedDeleteLevel(level) {
  deleteLevelModal.value.name = level;
  deleteLevelModal.value.visible = true;
}

function deleteLevel() {
  store
    .dispatch("game/deleteLevel", {
      game: game.value,
      level: deleteLevelModal.value.name,
    })
    .then(() => (deleteLevelModal.value.visible = false));
}

function clickedSession(level, session) {
  store.dispatch("live/selectSession", session);
  router.push({
    name: "Editor",
    params: { game: game.value, level },
  });
}

function clickedDeleteSession(session) {
  store.dispatch("live/cancelSession", { game: game.value, session });
}

function clickedLevel(level) {
  router.push({
    name: "Editor",
    params: { game: game.value, level },
  });
}

function updateLevelStatus(level, status) {
  store.dispatch("level/editStatus", { level, status });
}
</script>

<template>
  <div class="p-4 is-flex is-flex-direction-column">
    <h1 class="subtitle">{{ isLive ? "SESSIONS" : "LEVEL" }} OVERVIEW</h1>
    <section v-if="levels" class="py-2 is-not-clipped is-max-full-height">
      <SessionList
        v-if="isLive"
        :levels="levels"
        :sessions="sessions"
        @session-select="clickedSession"
        @session-delete="clickedDeleteSession"
        @level-select="clickedSession"
      />
      <LevelList
        v-else
        :levels="levels"
        @level-select="clickedLevel"
        @level-delete="clickedDeleteLevel"
        @level-update="updateLevelStatus"
      />
    </section>

    <!-- ADD BUTTON -->
    <section v-if="!isLive" class="mt-5">
      <AddLevelModal>
        <template #anchor="{ onClick }">
          <button class="button is-link" @click="onClick">NEW LEVEL</button>
        </template>
      </AddLevelModal>
    </section>

    <!-- DELETE MODAL -->
    <ModalOverlay
      v-if="deleteLevelModal.visible"
      :modal="deleteLevelModal"
      :css-classes="['is-danger']"
      @close-modal="deleteLevelModal.visible = false"
    >
      <template #header>DELETE LEVEL</template>
      Do you really want do delete level
      <b>{{ deleteLevelModal.name }}</b>
      ?
      <template #footer>
        <button class="button is-danger m-1" @click="deleteLevel">DELETE</button>
        <button class="button m-1" @click="deleteLevelModal.visible = false">CANCEL</button>
      </template>
    </ModalOverlay>
  </div>
</template>
